#include <HT32F125x.h>                    // 

#include <stdio.h>

#include "flash.h"

typedef struct {
	int data;
	uint8_t wasted3bytes;
} myconfig_t;

myconfig_t myconfig;

typedef struct {
	uint32_t data[9];
} optbyte_t;


void FLASH_erase(void)
{
	HT_FLASH->OCMR = FLASH_CMD_PAGEERASE;
	HT_FLASH->TADR = 0x1FF00000;
	HT_FLASH->OPCR = FLASH_SEND_MAIN;  
	while((HT_FLASH->OPCR & FLASH_READY) != FLASH_READY);
}

void FLASH_write(uint32_t *faddr,uint32_t *addr, int len)
{
	if(len&3)
		len=(len>>2)+1;
	else len>>=2;
	HT_FLASH->OCMR = FLASH_CMD_PROGRAM;
	while(len--){
		HT_FLASH->TADR = (uint32_t)faddr++;
		HT_FLASH->WRDR = *(addr++);
		HT_FLASH->OPCR = FLASH_SEND_MAIN;  
		while((HT_FLASH->OPCR & FLASH_READY) != FLASH_READY);
	}
}


void saveconfig(void)
{
optbyte_t saveopt;

	saveopt=(*(optbyte_t *)0x1FF00000);						// save option byte to stack
	FLASH_erase();									// erase page
	FLASH_write((uint32_t *)0x1FF00000,(uint32_t *)&saveopt,sizeof(optbyte_t));	// restore option byte to stack
	FLASH_write((uint32_t *)0x1FF00050,(uint32_t *)&myconfig, sizeof(myconfig));	// copy config data
	HT_FLASH->OPCR = FLASH_IDLE;
}

void readconfig(void)
{
	myconfig=(*(myconfig_t *)0x1FF00050);
}


/* MAIN PROGRAM */

main()
{
	myconfig.data=0x12345678;
	saveconfig();				// save config
	readconfig();				// read it back
	while(1);
}

